#include <windows.h>
#include <stdio.h>
#include <rtapi.h>
#include "gsc16Ai32.h"

unsigned long  buffer[32*1024];
void test1(void);
void test2(void);
void test3(void);
void test4(void);
void test5(void);


int main(int argc, char *argv[])
{
	if(argc<=1)
	{
				test1();
				return 0;
	}
	switch (argv[1][0])
	{
	case '1':
		// acquisition channel 0 of 0 trigger channel header with time tag
		// with 10k sampling clock
		// without updating the ref value
		test1();
		break;
	case '2':
		// acquisition channel 0 of 0 trigger channel header with time tag
		// With 10k sampling clock
		// Update the ref value
		test2();
		break;
	case '3':
		// acquisition channel 0 of 0 trigger channel header with time tag
		// Sampling to external clock
		// Without updating the ref value
		test3();
		break;
	case '4':
		// acquisition channel 0 of 0 trigger channel header with time tag
		// Sampling to external clock
		// Update the ref value
		test4();
		break;
	case '5':
		// acquisition channel 0 of 0 trigger channel header with time tag
		// With 10k sampling clock
		// Without updating the ref value
		// External reset dating and extern
		test5();
		break;
	default:
		break;

	}
	return 0;
}
void test1(void)
{
	int nStatus = 0;
	char szDriverRevision[255];
	char szFirmwareRevision[255];
	unsigned int regval;
	size_t nbval;
	int i,j;
	HANDLE hThresEvent;

	printf ("init card\n");
	nStatus = GSC16AI32_Init(0);

	printf ("EnableTimeTag\n");
	GSC16AI32_EnableTimeTag(0);
	printf ("revisionQuery\n");
	nStatus = GSC16AI32_revisionQuery(0, szDriverRevision, szFirmwareRevision );
	printf("%s,%s\n",szDriverRevision,szFirmwareRevision);
	GSC16AI32_Autocal(0);


	GSC16AI32_ReadLocal32(0,0,&regval);
	printf("BCR=%x\n",regval);
	GSC16AI32_ReadLocal32(0,1,&regval);
	printf("ICR=%x\n",regval);
	GSC16AI32_ReadLocal32(0,2,&regval);
	printf("IDB=%x\n",regval);
	GSC16AI32_ReadLocal32(0,3,&regval);
	printf("IBC=%x\n",regval);
	GSC16AI32_ReadLocal32(0,4,&regval);
	printf("RATE A=%x\n",regval);
	GSC16AI32_ReadLocal32(0,5,&regval);
	printf("RATE B=%x\n",regval);
	GSC16AI32_ReadLocal32(0,6,&regval);
	printf("BUFFER SIZE=%x\n",regval);
	GSC16AI32_ReadLocal32(0,7,&regval);
	printf("BURST SIZE=%x\n",regval);
	GSC16AI32_ReadLocal32(0,8,&regval);
	printf("SSC=%x\n",regval);
	GSC16AI32_ReadLocal32(0,9,&regval);
	printf("ACA=%x\n",regval);
	GSC16AI32_ReadLocal32(0,10,&regval);
	printf("BOARD CONF=%x\n",regval);
	GSC16AI32_ReadLocal32(0,11,&regval);
	printf("AUTOCAL=%x\n",regval);
	GSC16AI32_ReadLocal32(0,20,&regval);
	printf("TTC=%x\n",regval);
	GSC16AI32_ReadLocal32(0,21,&regval);
	printf("ACM=%x\n",regval);
	GSC16AI32_ReadLocal32(0,22,&regval);
	printf("TIME TAG COUNTER LOW=%x\n",regval);
	GSC16AI32_ReadLocal32(0,23,&regval);
	printf("TIME TAG COUNTER HIGH=%x\n",regval);

	printf ("GenDisableA\n");
	GSC16AI32_GenDisableA(0);
	GSC16AI32_ReadLocal32(0,0,&regval);
	printf("BCR=%x\n",regval);
	GSC16AI32_ReadLocal32(0,4,&regval);
	printf("RATE A=%x\n",regval);
	
	printf ("GenDisableB\n");
	GSC16AI32_GenDisableB(0);
	GSC16AI32_ReadLocal32(0,0,&regval);
	printf("BCR=%x\n",regval);
	GSC16AI32_ReadLocal32(0,5,&regval);
	printf("RATE B=%x\n",regval);
	// config input
	printf ("InputRangeConfig\n");
	GSC16AI32_InputRangeConfig(0,INPUT_RANGE_10);
	GSC16AI32_ReadLocal32(0,0,&regval);
	printf("BCR=%x\n",regval);
	
	printf ("InputModeConfig\n");
	GSC16AI32_InputModeConfig(0,INPUT_DIFFERENTIAL);
	GSC16AI32_ReadLocal32(0,0,&regval);
	printf("BCR=%x\n",regval);

	GSC16AI32_InputFormatConfig(0,FORMAT_OFFSET_BINARY);
	
	printf ("SetScanSize\n");
	GSC16AI32_SetScanSize(0,SCAN_32_CHAN);
	GSC16AI32_ReadLocal32(0,8,&regval);
	printf("SSC=%x\n",regval);
	// config internal sampling frequency
	printf ("SetScanRateA\n");
	GSC16AI32_SetScanRateA(0,2500);
	GSC16AI32_ReadLocal32(0,4,&regval);
	printf("RATE A=%x\n",regval);
	// config dma
	printf ("EnableDma\n");
	GSC16AI32_SetDmaMode(0,DMA_ENABLE);

	printf ("SetBufferThres\n");
	GSC16AI32_SetBufferThres(0,0x4000);
	GSC16AI32_ReadLocal32(0,3,&regval);
	printf("IBC=%x\n",regval);
	// config sampling
	GSC16AI32_SetScanClock(0,INTERNAL_RATE_A);
	GSC16AI32_SetTimeTagConfScanClock(0,TTC_INTERNAL_RATE_A);
	GSC16AI32_EnableTimeTagHeader(0);
	GSC16AI32_SetChannelReference(0,0, 0x8000);
	GSC16AI32_SetChannelThreshold(0,0,0xCCC);
	GSC16AI32_SetChannelReference(0,1, 0x8000);
	GSC16AI32_SetChannelThreshold(0,1,0x4000);
	GSC16AI32_EnableTriggerMode(0);
	GSC16AI32_EnableGlobalTriggering(0);
	//GSC16AI32_DisableGlobalTriggering(0);
	GSC16AI32_DisableUpdateRefVal(0);
	GSC16AI32_SetTimeTagActiveChannelMask(0,3);
	GSC16AI32_SetTimeTagBurstSize(0,1);
	GSC16AI32_GetEventHandle(0,THRES_LO_HI,&hThresEvent);

	GSC16AI32_ReadLocal32(0,1,&regval);	
	printf("ICR=%x\n",regval);

	// start sampling
	GSC16AI32_GenTimeTagEnable(0);
	GSC16AI32_ScanClockEnable(0);
	printf ("GenEnableA\n");
	GSC16AI32_GenEnableA(0);
	GSC16AI32_ReadLocal32(0,0,&regval);
	printf("BCR=%x\n",regval);
	
	//RtSleep(100);
	//printf ("GenDisableA\n");
	//GSC16AI32_GenDisableA(0);

	// read sampling bloc
	for(j=0;j<5;j++)
	{
	RtWaitForSingleObject(hThresEvent,20000);
	GSC16AI32_ReadLocal32(0,6,&regval);	
	printf("BUFFER SIZE=%x\n",regval);
	GSC16AI32_ReadLocal32(0,1,&regval);	
	printf("ICR=%x\n",regval);
	
	printf ("ReadBuffer\n");
	nbval = GSC16AI32_ReadBuffer(0, (char*)buffer, sizeof(buffer));
	printf("nbval =%ld\n",nbval);
/*	printf("buffer[0]=%x,buffer[1]=%x\n",buffer[0],buffer[1]);
	printf("buffer[2]=%x,buffer[3]=%x\n",buffer[2],buffer[3]);
	for(i= 0;i < buffer[3];i++)
		printf("buffer[4+%d]=%x\n",i,buffer[4+i]);
	printf("buffer[4+i]=%x,buffer[4+i+1]=%x\n",buffer[4+i],buffer[4+i+1]);
	printf("buffer[4+i+2]=%x,buffer[4+i+3]=%x\n",buffer[4+i+2],buffer[4+i+3]);
*/
	for(i=0;i<32;i+=2)
	{
		printf("buffer[%d]=%08lx,buffer[%d]=%08lx\n",i,buffer[i],i+1,buffer[i+1]);
	}
	}
	printf ("GenDisableA\n");
	GSC16AI32_GenDisableA(0);

	GSC16AI32_ReadLocal32(0,0,&regval);
	printf("BCR=%x\n",regval);
	GSC16AI32_ReadLocal32(0,1,&regval);
	printf("ICR=%x\n",regval);
	GSC16AI32_ReadLocal32(0,2,&regval);
	printf("IDB=%x\n",regval);
	GSC16AI32_ReadLocal32(0,3,&regval);
	printf("IBC=%x\n",regval);
	GSC16AI32_ReadLocal32(0,4,&regval);
	printf("RATE A=%x\n",regval);
	GSC16AI32_ReadLocal32(0,5,&regval);
	printf("RATE B=%x\n",regval);
	GSC16AI32_ReadLocal32(0,6,&regval);
	printf("BUFFER SIZE=%x\n",regval);
	GSC16AI32_ReadLocal32(0,7,&regval);
	printf("BURST SIZE=%x\n",regval);
	GSC16AI32_ReadLocal32(0,8,&regval);
	printf("SSC=%x\n",regval);
	GSC16AI32_ReadLocal32(0,9,&regval);
	printf("ACA=%x\n",regval);
	GSC16AI32_ReadLocal32(0,10,&regval);
	printf("BOARD CONF=%x\n",regval);
	GSC16AI32_ReadLocal32(0,11,&regval);
	printf("AUTOCAL=%x\n",regval);
	GSC16AI32_ReadLocal32(0,20,&regval);
	printf("TTC=%x\n",regval);
	GSC16AI32_ReadLocal32(0,21,&regval);
	printf("ACM=%x\n",regval);
	GSC16AI32_ReadLocal32(0,22,&regval);
	printf("TIME TAG COUNTER LOW=%x\n",regval);
	GSC16AI32_ReadLocal32(0,23,&regval);
	printf("TIME TAG COUNTER HIGH=%x\n",regval);

	nStatus = GSC16AI32_Close(0);
}

void test2(void)
{
	int nStatus = 0;
	char szDriverRevision[255];
	char szFirmwareRevision[255];
	unsigned int regval;
	size_t nbval;
	int i;

	printf ("init card\n");
	nStatus = GSC16AI32_Init(0);

	printf ("EnableTimeTag\n");
	GSC16AI32_EnableTimeTag(0);
	printf ("revisionQuery\n");
	nStatus = GSC16AI32_revisionQuery(0, szDriverRevision, szFirmwareRevision );
	printf("%s,%s\n",szDriverRevision,szFirmwareRevision);
	GSC16AI32_Autocal(0);


	GSC16AI32_ReadLocal32(0,0,&regval);
	printf("BCR=%x\n",regval);
	GSC16AI32_ReadLocal32(0,1,&regval);
	printf("ICR=%x\n",regval);
	GSC16AI32_ReadLocal32(0,2,&regval);
	printf("IDB=%x\n",regval);
	GSC16AI32_ReadLocal32(0,3,&regval);
	printf("IBC=%x\n",regval);
	GSC16AI32_ReadLocal32(0,4,&regval);
	printf("RATE A=%x\n",regval);
	GSC16AI32_ReadLocal32(0,5,&regval);
	printf("RATE B=%x\n",regval);
	GSC16AI32_ReadLocal32(0,6,&regval);
	printf("BUFFER SIZE=%x\n",regval);
	GSC16AI32_ReadLocal32(0,7,&regval);
	printf("BURST SIZE=%x\n",regval);
	GSC16AI32_ReadLocal32(0,8,&regval);
	printf("SSC=%x\n",regval);
	GSC16AI32_ReadLocal32(0,9,&regval);
	printf("ACA=%x\n",regval);
	GSC16AI32_ReadLocal32(0,10,&regval);
	printf("BOARD CONF=%x\n",regval);
	GSC16AI32_ReadLocal32(0,11,&regval);
	printf("AUTOCAL=%x\n",regval);
	GSC16AI32_ReadLocal32(0,20,&regval);
	printf("TTC=%x\n",regval);
	GSC16AI32_ReadLocal32(0,21,&regval);
	printf("ACM=%x\n",regval);
	GSC16AI32_ReadLocal32(0,22,&regval);
	printf("TIME TAG COUNTER LOW=%x\n",regval);
	GSC16AI32_ReadLocal32(0,23,&regval);
	printf("TIME TAG COUNTER HIGH=%x\n",regval);

	printf ("GenDisableA\n");
	GSC16AI32_GenDisableA(0);
	GSC16AI32_ReadLocal32(0,0,&regval);
	printf("BCR=%x\n",regval);
	GSC16AI32_ReadLocal32(0,4,&regval);
	printf("RATE A=%x\n",regval);
	
	printf ("GenDisableB\n");
	GSC16AI32_GenDisableB(0);
	GSC16AI32_ReadLocal32(0,0,&regval);
	printf("BCR=%x\n",regval);
	GSC16AI32_ReadLocal32(0,5,&regval);
	printf("RATE B=%x\n",regval);

	printf ("InputRangeConfig\n");
	GSC16AI32_InputRangeConfig(0,INPUT_RANGE_10);
	GSC16AI32_ReadLocal32(0,0,&regval);
	printf("BCR=%x\n",regval);
	
	printf ("InputModeConfig\n");
	GSC16AI32_InputModeConfig(0,INPUT_DIFFERENTIAL);
	GSC16AI32_ReadLocal32(0,0,&regval);
	printf("BCR=%x\n",regval);
	
	printf ("SetScanSize\n");
	GSC16AI32_SetScanSize(0,SCAN_32_CHAN);
	GSC16AI32_ReadLocal32(0,8,&regval);
	printf("SSC=%x\n",regval);
	
	printf ("SetScanRateA\n");
	GSC16AI32_SetScanRateA(0,2500);
	GSC16AI32_ReadLocal32(0,4,&regval);
	printf("RATE A=%x\n",regval);
	printf ("EnableDma\n");
	
	GSC16AI32_SetDmaMode(0,DMA_ENABLE);
	//GSC16AI32_EnableDma(0,DMA_DISABLE);
	printf ("SetBufferThres\n");
	GSC16AI32_SetBufferThres(0,0x200);
	GSC16AI32_ReadLocal32(0,3,&regval);
	printf("IBC=%x\n",regval);
	GSC16AI32_SetScanClock(0,INTERNAL_RATE_A);
	GSC16AI32_SetTimeTagConfScanClock(0,TTC_INTERNAL_RATE_A);
	GSC16AI32_EnableTimeTagHeader(0);
	GSC16AI32_SetChannelReference(0,0, 0x8000);
	GSC16AI32_SetChannelThreshold(0,0,0xCCC);
	GSC16AI32_EnableTriggerMode(0);
	GSC16AI32_EnableGlobalTriggering(0);
	GSC16AI32_EnableUpdateRefVal(0);
	GSC16AI32_GenTimeTagEnable(0);
	GSC16AI32_ScanClockEnable(0);
	GSC16AI32_SetTimeTagActiveChannelMask(0,1);
	GSC16AI32_SetTimeTagBurstSize(0,1);
	GSC16AI32_ReadLocal32(0,1,&regval);	
	printf("ICR=%x\n",regval);
	printf ("GenEnableA\n");
	GSC16AI32_GenEnableA(0);
	GSC16AI32_ReadLocal32(0,0,&regval);
	printf("BCR=%x\n",regval);
	RtSleep(50);

	GSC16AI32_ReadLocal32(0,6,&regval);	
	printf("BUFFER SIZE=%x\n",regval);
	GSC16AI32_ReadLocal32(0,1,&regval);	
	printf("ICR=%x\n",regval);
	
	printf ("ReadBuffer\n");
	nbval = GSC16AI32_ReadBuffer(0, (char*)buffer, sizeof(buffer));
	printf("nbval =%d\n",nbval);
/*	printf("buffer[0]=%x,buffer[1]=%x\n",buffer[0],buffer[1]);
	printf("buffer[2]=%x,buffer[3]=%x\n",buffer[2],buffer[3]);
	for(i= 0;i < buffer[3];i++)
		printf("buffer[4+%d]=%x\n",i,buffer[4+i]);
	printf("buffer[4+i]=%x,buffer[4+i+1]=%x\n",buffer[4+i],buffer[4+i+1]);
	printf("buffer[4+i+2]=%x,buffer[4+i+3]=%x\n",buffer[4+i+2],buffer[4+i+3]);
*/
	for(i=0;i<64;i+=2)
	{
		printf("buffer[%d]=%08lx,buffer[%d]=%08lx\n",i,buffer[i],i+1,buffer[i+1]);
	}

	GSC16AI32_ReadLocal32(0,0,&regval);
	printf("BCR=%x\n",regval);
	GSC16AI32_ReadLocal32(0,1,&regval);
	printf("ICR=%x\n",regval);
	GSC16AI32_ReadLocal32(0,2,&regval);
	printf("IDB=%x\n",regval);
	GSC16AI32_ReadLocal32(0,3,&regval);
	printf("IBC=%x\n",regval);
	GSC16AI32_ReadLocal32(0,4,&regval);
	printf("RATE A=%x\n",regval);
	GSC16AI32_ReadLocal32(0,5,&regval);
	printf("RATE B=%x\n",regval);
	GSC16AI32_ReadLocal32(0,6,&regval);
	printf("BUFFER SIZE=%x\n",regval);
	GSC16AI32_ReadLocal32(0,7,&regval);
	printf("BURST SIZE=%x\n",regval);
	GSC16AI32_ReadLocal32(0,8,&regval);
	printf("SSC=%x\n",regval);
	GSC16AI32_ReadLocal32(0,9,&regval);
	printf("ACA=%x\n",regval);
	GSC16AI32_ReadLocal32(0,10,&regval);
	printf("BOARD CONF=%x\n",regval);
	GSC16AI32_ReadLocal32(0,11,&regval);
	printf("AUTOCAL=%x\n",regval);
	GSC16AI32_ReadLocal32(0,20,&regval);
	printf("TTC=%x\n",regval);
	GSC16AI32_ReadLocal32(0,21,&regval);
	printf("ACM=%x\n",regval);
	GSC16AI32_ReadLocal32(0,22,&regval);
	printf("TIME TAG COUNTER LOW=%x\n",regval);
	GSC16AI32_ReadLocal32(0,23,&regval);
	printf("TIME TAG COUNTER HIGH=%x\n",regval);

	nStatus = GSC16AI32_Close(0);
}

void test3(void)
{
	int nStatus = 0;
	char szDriverRevision[255];
	char szFirmwareRevision[255];
	unsigned int regval;
	size_t nbval;
	int i;

	printf ("init card\n");
	nStatus = GSC16AI32_Init(0);

	printf ("EnableTimeTag\n");
	GSC16AI32_EnableTimeTag(0);
	printf ("revisionQuery\n");
	nStatus = GSC16AI32_revisionQuery(0, szDriverRevision, szFirmwareRevision );
	printf("%s,%s\n",szDriverRevision,szFirmwareRevision);
	GSC16AI32_Autocal(0);


	GSC16AI32_ReadLocal32(0,0,&regval);
	printf("BCR=%x\n",regval);
	GSC16AI32_ReadLocal32(0,1,&regval);
	printf("ICR=%x\n",regval);
	GSC16AI32_ReadLocal32(0,2,&regval);
	printf("IDB=%x\n",regval);
	GSC16AI32_ReadLocal32(0,3,&regval);
	printf("IBC=%x\n",regval);
	GSC16AI32_ReadLocal32(0,4,&regval);
	printf("RATE A=%x\n",regval);
	GSC16AI32_ReadLocal32(0,5,&regval);
	printf("RATE B=%x\n",regval);
	GSC16AI32_ReadLocal32(0,6,&regval);
	printf("BUFFER SIZE=%x\n",regval);
	GSC16AI32_ReadLocal32(0,7,&regval);
	printf("BURST SIZE=%x\n",regval);
	GSC16AI32_ReadLocal32(0,8,&regval);
	printf("SSC=%x\n",regval);
	GSC16AI32_ReadLocal32(0,9,&regval);
	printf("ACA=%x\n",regval);
	GSC16AI32_ReadLocal32(0,10,&regval);
	printf("BOARD CONF=%x\n",regval);
	GSC16AI32_ReadLocal32(0,11,&regval);
	printf("AUTOCAL=%x\n",regval);
	GSC16AI32_ReadLocal32(0,20,&regval);
	printf("TTC=%x\n",regval);
	GSC16AI32_ReadLocal32(0,21,&regval);
	printf("ACM=%x\n",regval);
	GSC16AI32_ReadLocal32(0,22,&regval);
	printf("TIME TAG COUNTER LOW=%x\n",regval);
	GSC16AI32_ReadLocal32(0,23,&regval);
	printf("TIME TAG COUNTER HIGH=%x\n",regval);

	printf ("GenDisableA\n");
	GSC16AI32_GenDisableA(0);
	GSC16AI32_ReadLocal32(0,0,&regval);
	printf("BCR=%x\n",regval);
	GSC16AI32_ReadLocal32(0,4,&regval);
	printf("RATE A=%x\n",regval);
	
	printf ("GenDisableB\n");
	GSC16AI32_GenDisableB(0);
	GSC16AI32_ReadLocal32(0,0,&regval);
	printf("BCR=%x\n",regval);
	GSC16AI32_ReadLocal32(0,5,&regval);
	printf("RATE B=%x\n",regval);

	printf ("InputRangeConfig\n");
	GSC16AI32_InputRangeConfig(0,INPUT_RANGE_10);
	GSC16AI32_ReadLocal32(0,0,&regval);
	printf("BCR=%x\n",regval);
	
	printf ("InputModeConfig\n");
	GSC16AI32_InputModeConfig(0,INPUT_DIFFERENTIAL);
	GSC16AI32_ReadLocal32(0,0,&regval);
	printf("BCR=%x\n",regval);
	
	printf ("SetScanSize\n");
	GSC16AI32_SetScanSize(0,SCAN_32_CHAN);
	GSC16AI32_ReadLocal32(0,8,&regval);
	printf("SSC=%x\n",regval);
	
	printf ("SetScanRateA\n");
	GSC16AI32_SetScanRateA(0,2500);
	GSC16AI32_ReadLocal32(0,4,&regval);
	printf("RATE A=%x\n",regval);
	printf ("EnableDma\n");
	
	GSC16AI32_SetDmaMode(0,DMA_ENABLE);
	//GSC16AI32_EnableDma(0,DMA_DISABLE);
	printf ("SetBufferThres\n");
	GSC16AI32_SetBufferThres(0,0x200);
	GSC16AI32_ReadLocal32(0,3,&regval);
	printf("IBC=%x\n",regval);
	GSC16AI32_SetScanClock(0,EXTERNAL_SYNCH);
	GSC16AI32_SetTimeTagConfScanClock(0,TTC_EXTERNAL_SAMP_CLK);
	GSC16AI32_EnableTimeTagHeader(0);
	GSC16AI32_SetChannelReference(0,0, 0x8000);
	GSC16AI32_SetChannelThreshold(0,0,0x2);
	GSC16AI32_EnableTriggerMode(0);
	GSC16AI32_EnableGlobalTriggering(0);
	GSC16AI32_DisableUpdateRefVal(0);
	GSC16AI32_SetTimeTagActiveChannelMask(0,1);
	GSC16AI32_SetTimeTagBurstSize(0,1);
	GSC16AI32_GenTimeTagEnable(0);
	GSC16AI32_ScanClockEnable(0);

	GSC16AI32_ReadLocal32(0,1,&regval);	
	printf("ICR=%x\n",regval);

	//printf ("GenEnableA\n");
	//GSC16AI32_GenEnableA(0);
	GSC16AI32_ReadLocal32(0,0,&regval);
	printf("BCR=%x\n",regval);
	RtSleep(50);

	GSC16AI32_ReadLocal32(0,6,&regval);	
	printf("BUFFER SIZE=%x\n",regval);
	GSC16AI32_ReadLocal32(0,1,&regval);	
	printf("ICR=%x\n",regval);
	
	printf ("ReadBuffer\n");
	nbval = GSC16AI32_ReadBuffer(0, (char*)buffer, sizeof(buffer));
	printf("nbval =%d\n",nbval);
/*	printf("buffer[0]=%x,buffer[1]=%x\n",buffer[0],buffer[1]);
	printf("buffer[2]=%x,buffer[3]=%x\n",buffer[2],buffer[3]);
	for(i= 0;i < buffer[3];i++)
		printf("buffer[4+%d]=%x\n",i,buffer[4+i]);
	printf("buffer[4+i]=%x,buffer[4+i+1]=%x\n",buffer[4+i],buffer[4+i+1]);
	printf("buffer[4+i+2]=%x,buffer[4+i+3]=%x\n",buffer[4+i+2],buffer[4+i+3]);
*/
	for(i=0;i<64;i+=2)
	{
		printf("buffer[%d]=%08lx,buffer[%d]=%08lx\n",i,buffer[i],i+1,buffer[i+1]);
	}

	GSC16AI32_ReadLocal32(0,0,&regval);
	printf("BCR=%x\n",regval);
	GSC16AI32_ReadLocal32(0,1,&regval);
	printf("ICR=%x\n",regval);
	GSC16AI32_ReadLocal32(0,2,&regval);
	printf("IDB=%x\n",regval);
	GSC16AI32_ReadLocal32(0,3,&regval);
	printf("IBC=%x\n",regval);
	GSC16AI32_ReadLocal32(0,4,&regval);
	printf("RATE A=%x\n",regval);
	GSC16AI32_ReadLocal32(0,5,&regval);
	printf("RATE B=%x\n",regval);
	GSC16AI32_ReadLocal32(0,6,&regval);
	printf("BUFFER SIZE=%x\n",regval);
	GSC16AI32_ReadLocal32(0,7,&regval);
	printf("BURST SIZE=%x\n",regval);
	GSC16AI32_ReadLocal32(0,8,&regval);
	printf("SSC=%x\n",regval);
	GSC16AI32_ReadLocal32(0,9,&regval);
	printf("ACA=%x\n",regval);
	GSC16AI32_ReadLocal32(0,10,&regval);
	printf("BOARD CONF=%x\n",regval);
	GSC16AI32_ReadLocal32(0,11,&regval);
	printf("AUTOCAL=%x\n",regval);
	GSC16AI32_ReadLocal32(0,20,&regval);
	printf("TTC=%x\n",regval);
	GSC16AI32_ReadLocal32(0,21,&regval);
	printf("ACM=%x\n",regval);
	GSC16AI32_ReadLocal32(0,22,&regval);
	printf("TIME TAG COUNTER LOW=%x\n",regval);
	GSC16AI32_ReadLocal32(0,23,&regval);
	printf("TIME TAG COUNTER HIGH=%x\n",regval);

	nStatus = GSC16AI32_Close(0);
}

void test4(void)
{
	int nStatus = 0;
	char szDriverRevision[255];
	char szFirmwareRevision[255];
	unsigned int regval;
	size_t nbval;
	int i;

	printf ("init card\n");
	nStatus = GSC16AI32_Init(0);

	printf ("EnableTimeTag\n");
	GSC16AI32_EnableTimeTag(0);
	printf ("revisionQuery\n");
	nStatus = GSC16AI32_revisionQuery(0, szDriverRevision, szFirmwareRevision );
	printf("%s,%s\n",szDriverRevision,szFirmwareRevision);
	GSC16AI32_Autocal(0);


	GSC16AI32_ReadLocal32(0,0,&regval);
	printf("BCR=%x\n",regval);
	GSC16AI32_ReadLocal32(0,1,&regval);
	printf("ICR=%x\n",regval);
	GSC16AI32_ReadLocal32(0,2,&regval);
	printf("IDB=%x\n",regval);
	GSC16AI32_ReadLocal32(0,3,&regval);
	printf("IBC=%x\n",regval);
	GSC16AI32_ReadLocal32(0,4,&regval);
	printf("RATE A=%x\n",regval);
	GSC16AI32_ReadLocal32(0,5,&regval);
	printf("RATE B=%x\n",regval);
	GSC16AI32_ReadLocal32(0,6,&regval);
	printf("BUFFER SIZE=%x\n",regval);
	GSC16AI32_ReadLocal32(0,7,&regval);
	printf("BURST SIZE=%x\n",regval);
	GSC16AI32_ReadLocal32(0,8,&regval);
	printf("SSC=%x\n",regval);
	GSC16AI32_ReadLocal32(0,9,&regval);
	printf("ACA=%x\n",regval);
	GSC16AI32_ReadLocal32(0,10,&regval);
	printf("BOARD CONF=%x\n",regval);
	GSC16AI32_ReadLocal32(0,11,&regval);
	printf("AUTOCAL=%x\n",regval);
	GSC16AI32_ReadLocal32(0,20,&regval);
	printf("TTC=%x\n",regval);
	GSC16AI32_ReadLocal32(0,21,&regval);
	printf("ACM=%x\n",regval);
	GSC16AI32_ReadLocal32(0,22,&regval);
	printf("TIME TAG COUNTER LOW=%x\n",regval);
	GSC16AI32_ReadLocal32(0,23,&regval);
	printf("TIME TAG COUNTER HIGH=%x\n",regval);

	printf ("GenDisableA\n");
	GSC16AI32_GenDisableA(0);
	GSC16AI32_ReadLocal32(0,0,&regval);
	printf("BCR=%x\n",regval);
	GSC16AI32_ReadLocal32(0,4,&regval);
	printf("RATE A=%x\n",regval);
	
	printf ("GenDisableB\n");
	GSC16AI32_GenDisableB(0);
	GSC16AI32_ReadLocal32(0,0,&regval);
	printf("BCR=%x\n",regval);
	GSC16AI32_ReadLocal32(0,5,&regval);
	printf("RATE B=%x\n",regval);

	printf ("InputRangeConfig\n");
	GSC16AI32_InputRangeConfig(0,INPUT_RANGE_10);
	GSC16AI32_ReadLocal32(0,0,&regval);
	printf("BCR=%x\n",regval);
	
	printf ("InputModeConfig\n");
	GSC16AI32_InputModeConfig(0,INPUT_DIFFERENTIAL);
	GSC16AI32_ReadLocal32(0,0,&regval);
	printf("BCR=%x\n",regval);
	
	printf ("SetScanSize\n");
	GSC16AI32_SetScanSize(0,SCAN_32_CHAN);
	GSC16AI32_ReadLocal32(0,8,&regval);
	printf("SSC=%x\n",regval);
	
	printf ("SetScanRateA\n");
	GSC16AI32_SetScanRateA(0,2500);
	GSC16AI32_ReadLocal32(0,4,&regval);
	printf("RATE A=%x\n",regval);
	printf ("EnableDma\n");
	
	GSC16AI32_SetDmaMode(0,DMA_ENABLE);
	//GSC16AI32_EnableDma(0,DMA_DISABLE);
	printf ("SetBufferThres\n");
	GSC16AI32_SetBufferThres(0,0x200);
	GSC16AI32_ReadLocal32(0,3,&regval);
	printf("IBC=%x\n",regval);
	GSC16AI32_SetScanClock(0,EXTERNAL_SYNCH);
	GSC16AI32_SetTimeTagConfScanClock(0,TTC_EXTERNAL_SAMP_CLK);
	GSC16AI32_EnableTimeTagHeader(0);
	GSC16AI32_SetChannelReference(0,0, 0x8000);
	GSC16AI32_SetChannelThreshold(0,0,0x2);
	GSC16AI32_EnableTriggerMode(0);
	GSC16AI32_EnableGlobalTriggering(0);
	GSC16AI32_DisableUpdateRefVal(0);
	GSC16AI32_SetTimeTagActiveChannelMask(0,1);
	GSC16AI32_SetTimeTagBurstSize(0,1);
	GSC16AI32_ReadLocal32(0,1,&regval);	
	printf("ICR=%x\n",regval);
	GSC16AI32_GenTimeTagEnable(0);
	GSC16AI32_ScanClockEnable(0);

	//printf ("GenEnableA\n");
	//GSC16AI32_GenEnableA(0);
	GSC16AI32_ReadLocal32(0,0,&regval);
	printf("BCR=%x\n",regval);
	RtSleep(50);

	GSC16AI32_ReadLocal32(0,6,&regval);	
	printf("BUFFER SIZE=%x\n",regval);
	GSC16AI32_ReadLocal32(0,1,&regval);	
	printf("ICR=%x\n",regval);
	
	printf ("ReadBuffer\n");
	nbval = GSC16AI32_ReadBuffer(0, (char*)buffer, sizeof(buffer));
	printf("nbval =%d\n",nbval);
/*	printf("buffer[0]=%x,buffer[1]=%x\n",buffer[0],buffer[1]);
	printf("buffer[2]=%x,buffer[3]=%x\n",buffer[2],buffer[3]);
	for(i= 0;i < buffer[3];i++)
		printf("buffer[4+%d]=%x\n",i,buffer[4+i]);
	printf("buffer[4+i]=%x,buffer[4+i+1]=%x\n",buffer[4+i],buffer[4+i+1]);
	printf("buffer[4+i+2]=%x,buffer[4+i+3]=%x\n",buffer[4+i+2],buffer[4+i+3]);
*/
	for(i=0;i<64;i+=2)
	{
		printf("buffer[%d]=%08lx,buffer[%d]=%08lx\n",i,buffer[i],i+1,buffer[i+1]);
	}

	GSC16AI32_ReadLocal32(0,0,&regval);
	printf("BCR=%x\n",regval);
	GSC16AI32_ReadLocal32(0,1,&regval);
	printf("ICR=%x\n",regval);
	GSC16AI32_ReadLocal32(0,2,&regval);
	printf("IDB=%x\n",regval);
	GSC16AI32_ReadLocal32(0,3,&regval);
	printf("IBC=%x\n",regval);
	GSC16AI32_ReadLocal32(0,4,&regval);
	printf("RATE A=%x\n",regval);
	GSC16AI32_ReadLocal32(0,5,&regval);
	printf("RATE B=%x\n",regval);
	GSC16AI32_ReadLocal32(0,6,&regval);
	printf("BUFFER SIZE=%x\n",regval);
	GSC16AI32_ReadLocal32(0,7,&regval);
	printf("BURST SIZE=%x\n",regval);
	GSC16AI32_ReadLocal32(0,8,&regval);
	printf("SSC=%x\n",regval);
	GSC16AI32_ReadLocal32(0,9,&regval);
	printf("ACA=%x\n",regval);
	GSC16AI32_ReadLocal32(0,10,&regval);
	printf("BOARD CONF=%x\n",regval);
	GSC16AI32_ReadLocal32(0,11,&regval);
	printf("AUTOCAL=%x\n",regval);
	GSC16AI32_ReadLocal32(0,20,&regval);
	printf("TTC=%x\n",regval);
	GSC16AI32_ReadLocal32(0,21,&regval);
	printf("ACM=%x\n",regval);
	GSC16AI32_ReadLocal32(0,22,&regval);
	printf("TIME TAG COUNTER LOW=%x\n",regval);
	GSC16AI32_ReadLocal32(0,23,&regval);
	printf("TIME TAG COUNTER HIGH=%x\n",regval);

	nStatus = GSC16AI32_Close(0);
}
void test5(void)
{
	int nStatus = 0;
	char szDriverRevision[255];
	char szFirmwareRevision[255];
	unsigned int regval;
	size_t nbval;
	int i;

	printf ("init card\n");
	nStatus = GSC16AI32_Init(0);

	printf ("EnableTimeTag\n");
	GSC16AI32_EnableTimeTag(0);
	printf ("revisionQuery\n");
	nStatus = GSC16AI32_revisionQuery(0, szDriverRevision, szFirmwareRevision );
	printf("%s,%s\n",szDriverRevision,szFirmwareRevision);
	GSC16AI32_Autocal(0);


	GSC16AI32_ReadLocal32(0,0,&regval);
	printf("BCR=%x\n",regval);
	GSC16AI32_ReadLocal32(0,1,&regval);
	printf("ICR=%x\n",regval);
	GSC16AI32_ReadLocal32(0,2,&regval);
	printf("IDB=%x\n",regval);
	GSC16AI32_ReadLocal32(0,3,&regval);
	printf("IBC=%x\n",regval);
	GSC16AI32_ReadLocal32(0,4,&regval);
	printf("RATE A=%x\n",regval);
	GSC16AI32_ReadLocal32(0,5,&regval);
	printf("RATE B=%x\n",regval);
	GSC16AI32_ReadLocal32(0,6,&regval);
	printf("BUFFER SIZE=%x\n",regval);
	GSC16AI32_ReadLocal32(0,7,&regval);
	printf("BURST SIZE=%x\n",regval);
	GSC16AI32_ReadLocal32(0,8,&regval);
	printf("SSC=%x\n",regval);
	GSC16AI32_ReadLocal32(0,9,&regval);
	printf("ACA=%x\n",regval);
	GSC16AI32_ReadLocal32(0,10,&regval);
	printf("BOARD CONF=%x\n",regval);
	GSC16AI32_ReadLocal32(0,11,&regval);
	printf("AUTOCAL=%x\n",regval);
	GSC16AI32_ReadLocal32(0,20,&regval);
	printf("TTC=%x\n",regval);
	GSC16AI32_ReadLocal32(0,21,&regval);
	printf("ACM=%x\n",regval);
	GSC16AI32_ReadLocal32(0,22,&regval);
	printf("TIME TAG COUNTER LOW=%x\n",regval);
	GSC16AI32_ReadLocal32(0,23,&regval);
	printf("TIME TAG COUNTER HIGH=%x\n",regval);

	printf ("GenDisableA\n");
	GSC16AI32_GenDisableA(0);
	GSC16AI32_ReadLocal32(0,0,&regval);
	printf("BCR=%x\n",regval);
	GSC16AI32_ReadLocal32(0,4,&regval);
	printf("RATE A=%x\n",regval);
	
	printf ("GenDisableB\n");
	GSC16AI32_GenDisableB(0);
	GSC16AI32_ReadLocal32(0,0,&regval);
	printf("BCR=%x\n",regval);
	GSC16AI32_ReadLocal32(0,5,&regval);
	printf("RATE B=%x\n",regval);
	// config input
	printf ("InputRangeConfig\n");
	GSC16AI32_InputRangeConfig(0,INPUT_RANGE_10);
	GSC16AI32_ReadLocal32(0,0,&regval);
	printf("BCR=%x\n",regval);
	
	printf ("InputModeConfig\n");
	GSC16AI32_InputModeConfig(0,INPUT_DIFFERENTIAL);
	GSC16AI32_ReadLocal32(0,0,&regval);
	printf("BCR=%x\n",regval);

	GSC16AI32_InputFormatConfig(0,FORMAT_OFFSET_BINARY);
	
	printf ("SetScanSize\n");
	GSC16AI32_SetScanSize(0,SCAN_32_CHAN);
	GSC16AI32_ReadLocal32(0,8,&regval);
	printf("SSC=%x\n",regval);
	// config internal sampling frequency
	printf ("SetScanRateA\n");
	GSC16AI32_SetScanRateA(0,2500);
	GSC16AI32_ReadLocal32(0,4,&regval);
	printf("RATE A=%x\n",regval);
	// config dma
	printf ("EnableDma\n");
	GSC16AI32_SetDmaMode(0,DMA_ENABLE);

	printf ("SetBufferThres\n");
	GSC16AI32_SetBufferThres(0,0x200);
	GSC16AI32_ReadLocal32(0,3,&regval);
	printf("IBC=%x\n",regval);
	// config datation
	GSC16AI32_SetTimeTagConf(0,TTC_EXTERNAL);
	GSC16AI32_ResetTimeTagConf(0,TTC_EXTERNAL_RESET);
	// config sampling
	GSC16AI32_SetScanClock(0,INTERNAL_RATE_A);
	GSC16AI32_SetTimeTagConfScanClock(0,TTC_INTERNAL_RATE_A);
 	GSC16AI32_EnableTimeTagHeader(0);
	GSC16AI32_SetChannelReference(0,0, 0x8000);
	GSC16AI32_SetChannelThreshold(0,0,0xCCC);
	GSC16AI32_EnableTriggerMode(0);
	GSC16AI32_EnableGlobalTriggering(0);
	GSC16AI32_DisableUpdateRefVal(0);
	GSC16AI32_SetTimeTagActiveChannelMask(0,1);
	GSC16AI32_SetTimeTagBurstSize(0,1);
	GSC16AI32_ReadLocal32(0,1,&regval);	
	printf("ICR=%x\n",regval);

	// start sampling
	GSC16AI32_GenTimeTagEnable(0);
	GSC16AI32_ScanClockEnable(0);
	printf ("GenEnableA\n");
	GSC16AI32_GenEnableA(0);
	GSC16AI32_ReadLocal32(0,0,&regval);
	printf("BCR=%x\n",regval);
	
	RtSleep(50);
	printf ("GenDisableA\n");
	GSC16AI32_GenDisableA(0);

	// read sampling bloc
	GSC16AI32_ReadLocal32(0,6,&regval);	
	printf("BUFFER SIZE=%x\n",regval);
	GSC16AI32_ReadLocal32(0,1,&regval);	
	printf("ICR=%x\n",regval);
	
	printf ("ReadBuffer\n");
	nbval = GSC16AI32_ReadBuffer(0, (char*)buffer, sizeof(buffer));
	printf("nbval =%d\n",nbval);
/*	printf("buffer[0]=%x,buffer[1]=%x\n",buffer[0],buffer[1]);
	printf("buffer[2]=%x,buffer[3]=%x\n",buffer[2],buffer[3]);
	for(i= 0;i < buffer[3];i++)
		printf("buffer[4+%d]=%x\n",i,buffer[4+i]);
	printf("buffer[4+i]=%x,buffer[4+i+1]=%x\n",buffer[4+i],buffer[4+i+1]);
	printf("buffer[4+i+2]=%x,buffer[4+i+3]=%x\n",buffer[4+i+2],buffer[4+i+3]);
*/
	for(i=0;i<64;i+=2)
	{
		printf("buffer[%d]=%08lx,buffer[%d]=%08lx\n",i,buffer[i],i+1,buffer[i+1]);
	}

	GSC16AI32_ReadLocal32(0,0,&regval);
	printf("BCR=%x\n",regval);
	GSC16AI32_ReadLocal32(0,1,&regval);
	printf("ICR=%x\n",regval);
	GSC16AI32_ReadLocal32(0,2,&regval);
	printf("IDB=%x\n",regval);
	GSC16AI32_ReadLocal32(0,3,&regval);
	printf("IBC=%x\n",regval);
	GSC16AI32_ReadLocal32(0,4,&regval);
	printf("RATE A=%x\n",regval);
	GSC16AI32_ReadLocal32(0,5,&regval);
	printf("RATE B=%x\n",regval);
	GSC16AI32_ReadLocal32(0,6,&regval);
	printf("BUFFER SIZE=%x\n",regval);
	GSC16AI32_ReadLocal32(0,7,&regval);
	printf("BURST SIZE=%x\n",regval);
	GSC16AI32_ReadLocal32(0,8,&regval);
	printf("SSC=%x\n",regval);
	GSC16AI32_ReadLocal32(0,9,&regval);
	printf("ACA=%x\n",regval);
	GSC16AI32_ReadLocal32(0,10,&regval);
	printf("BOARD CONF=%x\n",regval);
	GSC16AI32_ReadLocal32(0,11,&regval);
	printf("AUTOCAL=%x\n",regval);
	GSC16AI32_ReadLocal32(0,20,&regval);
	printf("TTC=%x\n",regval);
	GSC16AI32_ReadLocal32(0,21,&regval);
	printf("ACM=%x\n",regval);
	GSC16AI32_ReadLocal32(0,22,&regval);
	printf("TIME TAG COUNTER LOW=%x\n",regval);
	GSC16AI32_ReadLocal32(0,23,&regval);
	printf("TIME TAG COUNTER HIGH=%x\n",regval);

	nStatus = GSC16AI32_Close(0);
}
